<template>
    <v-layout 
      class="white--text justify-center" 
      row ma-4>
      <v-flex xs12 md8 text-center>
        <h2 class="text-left text-uppercase">
          <v-autocomplete
            dark
            v-model="selected_symbol"
            :items="symbols_list"
            v-on:change="startWebSocket()"
            outlined
            label="Symbols"
            class="text-uppercase"
          ></v-autocomplete>
        </h2>
      </v-flex>
      <v-flex xs12>
        <v-simple-table
          dark
          dense
          class="transparent white--text"
        >
          <template>
            <thead>
              <tr>
                <th class="text-center">Trade AB</th>
                <th class="text-center">Trade BC</th>
                <th class="text-center">Trade CA</th>
              </tr>
            </thead>
            <tbody>
              <tr v-for="(item, index) in trades" :key="index" class="text-center">
                <th>
                  {{item.ab}}
                </th>
                <th>
                  {{item.bc}}
                </th>
                <th>
                  {{item.ca}}
                </th>
              </tr>
            </tbody>
          </template>
        </v-simple-table>
      </v-flex>
      <v-flex xs12 md10
       v-if="market_depth"
      >
        <v-simple-table
          dark
          dense
          class="transparent white--text"
        >
          <template>
            <thead>
              <tr>
                <th class="text-right caption" width="15%">Price</th>
                <th class="text-center" width="20%">Exchanged Volume</th>
                <th class="text-center" width="20%">Bid Volume</th>
                <th class="text-center caption" width="10%">Sell</th>
                <th class="text-center caption" width="10%">Buy</th>
                <th class="text-center caption" width="20%">Ask Volume</th>
              </tr>
            </thead>
            <tbody>
              <tr v-for="(item, index) in chart_depth" :key="index+'ask'">
                <td :class="index == ask.length - 1 && price_up ? 'text-right green darken-4' : 'text-right'">
                  <v-icon v-if="index == ask.length - 1 && price_up" large class="mr-1" color="success">mdi-menu-up</v-icon>
                   <v-icon v-if="index == ask.length - 1 && !price_up" large class="mr-1" color="error">mdi-menu-down</v-icon>
                  <b :class="index == ask.length - 1 ? price_up ? 'success--text' : 'pink--text':''">
                    {{ best_offer.b ? parseFloat((best_offer.b + (item / chart_precision)), 10) : 0 }}
                  </b>
                </td>
                <td :class="index == ask.length - 1 && price_up ? 'text-right green darken-4' : 'text-right'">
                  <v-progress-linear 
                    color="grey"
                    height="20"
                    class="white--text text-trucate"
                    :value="history[item[0]] ? history[item[0]] / max_hist_volume * 100 : 0"
                  >
                    {{ history[item[0]] ? history[item[0]].toFixed(6) : '' }}
                  </v-progress-linear>
                </td>
                <td :class="index == ask.length - 1 && price_up ? 'text-right green darken-4' : 'text-center'">
                  <v-progress-linear 
                    background-color="blue"
                    color="blue darken-4"
                    height="20"
                    :value="100"
                  >
                  </v-progress-linear>
                </td>
                <td :class="index == ask.length - 1 && price_up ? 'text-right green darken-4' : 'text-center'">
                  <b class="pink--text"></b>
                </td>
                <td :class="index == ask.length - 1 && price_up ? 'text-center green darken-4' : 'text-center'">
                  <b class="blue--text text--lighten-3" v-if="index == ask.length - 1">{{ index == ask.length - 1 ? buys.toFixed(6) : '' }}</b>
                </td>
                <td :class="index == ask.length - 1 && price_up ? 'text-right green darken-4' : 'text-right'">
                  <v-progress-linear 
                    color="pink"
                    class="white--text"
                    height="20" 
                    :value="item[1] / max_volume * 100"
                  >
                      {{ Math.floor(parseFloat(item[1], 10)) }}
                    </v-progress-linear>
                </td>
              </tr>
              <tr v-for="(item, index) in bid" :key="index+'bid'">
                <td class="text-right">
                  <b 
                    :class="index == 0 ? 'primary--text text--lighten-2':''"
                  >
                    {{ item.p }}
                    <!--{{ item[0] ? parseFloat(item[0], 10) : 0 }}-->
                  </b>
                </td>
                <td>
                  <v-progress-linear 
                    color="grey"
                    height="20"
                    class="white--text"
                    :value="item.V_rate"
                  >
                    {{ item.V }}
                  </v-progress-linear>
                </td>
                <td>
                  <v-progress-linear 
                    height="20"
                    background-color="blue"
                    color="blue darken-4"
                    class="white--text"
                    :value="100 - ((item[1] / max_volume) * 100)"
                  >
                     {{ item.v }}
                  </v-progress-linear>
                </td>
                <td class="text-center">
                  <b class="pink--text">{{ index == 0 ? sells.toFixed(6) : '' }}</b>
                </td>
                <td></td>
                <td>
                  <v-progress-linear 
                    color="pink"
                    height="20"
                    :value="0"
                  >
                  </v-progress-linear>
                </td>
              </tr>
            </tbody>
          </template>
        </v-simple-table>
      </v-flex>
    </v-layout>
</template>

<script>
import axios from 'axios'

  export default {
    name: 'OrderBook',
    data: () => ({
      socket: null,
      symbols: null,
      selected_symbol: 'btcusdt',
      depth: 'depth20',
      freq: '100ms',
      chart_depth: 20,
      chart_precision: 100,
      market_depth: null,
      data: null,
      data_bid: [],
      data_ask: null,
      max_ask: null,
      max_bid: null,
      max_volume: 0,
      timestamp: [],
      best_offer: null,
      price_up: false,
      history: {},
      history_heatmap: [],
      total_trades: 0,
      max_hist_volume: 0,
      current_buy_price: null,
      current_sell_price: null,
      buys: 0,
      sells: 0,
      prices: {},
      budget: 100,
      fees: 0.075,
    }),
    async mounted(){
      //Get symbol from local storage
      if(localStorage.getItem('symbol')){
        this.selected_symbol = localStorage.getItem('symbol')
      }
      
      let list_symbols = await axios.get('http://localhost:8081/https://api.binance.com/api/v3/exchangeInfo')
      this.symbols = list_symbols.data.symbols.map(el => el)

      this.startWebSocket()

      //Init history from Binance API
      //this.getMarketHistory()

      //Periodic save history to local storage
      setInterval(this.saveHistory, 10000)
    },
    computed: {
      symbols_list(){
        let symbol
        if(this.symbols){
          symbol = this.symbols.map(el => el.quoteAsset)
        }
        return symbol
      },
      bookTicker(){
        this.best_offer ? Object.assign(this.prices, {[this.best_offer.s]: this.best_offer}) : null
        return this.best_offer
      },
      trade(){
        let res
        if(this.best_offer){
          Object.assign(this.prices, {[this.best_offer.s]: this.best_offer})

          let buy_calc = (this.budget - (this.budget * this.fees)) / this.prices.ETHUSDT.a
          let sell_symbol_calc = (buy_calc - (buy_calc * this.fees)) * this.prices.ETHBTC.b
          let sell_usd_calc = (sell_symbol_calc - (sell_symbol_calc * this.fees)) * this.prices.BTCUSDT.b

          res = {buy: buy_calc, sell_symbol: sell_symbol_calc, sell_usd: sell_usd_calc}
        } else {
          res = {buy: 0, sell_symbol: 0, sell_usd: 0}
        }
        return res
      },
      market(){
        return this.market_depth ? this.market_depth : null
      },
      trades(){
        let res = []
        if(this.symbols){
          this.symbols.forEach(el_a => {
            let a
            let b
            let c
            let f = []
            el_a.quoteAsset == this.selected_symbol ? a = el_a.symbol : ''
            if(a){
              this.symbols.find(find => {
                if(find.quoteAsset != this.selected_symbol){
                  f.push(find.quoteAsset)
                  return find.quoteAsset
                }
              })
              console.log('f', f)
              /*f.forEach(el => {
                if(el.find(el.quoteAsset == this.selected_symbol)){
                  b = el.baseAsset
                }
              })*/
              b = el_a.baseAsset + f
              c = f + this.selected_symbol
              res.push({ab: a, bc: b, ca: c})
            }
          })
        }
  
        console.log('res', res)
        return res
      },
      websocket_symboles(){
        let uri
        if(this.trades){
          this.trades.forEach(el => {
            uri = uri + el.ab.toLowerCase() + '@bookTicker/' + el.ab.toLowerCase() +'@bookTicker/'
          })
          uri = uri + 'btcusdt@bookTicker'
        }
        console.log('uri', uri)
        return uri
      },
      trade_ab(){
        let relation
        if(this.symbols){
          relation = this.symbols.filter(el => el.quoteAsset == this.selected_symbol)
        }
        return relation
      },
      trade_bc(){
        let relation
        if(this.trade_ab){
          let array = []
          this.trade_ab.map(el => {
           array.push(this.symbols.find(filter => filter.baseAsset == el.baseAsset && filter.quoteAsset != this.selected_symbol))
          })
          array.forEach((el, index, object) => {
            if(this.symbols.find(find => el.baseAsset == find.baseAsset && find.quoteAsset != this.selected_symbol).length < 1){
              object.splice(index, 1)
            }
          })
          relation = array
        }
        //console.log(relation)
        return relation
      },
      trade_ca(){
        let relation
        if(this.trade_bc){
          let array = []
          this.trade_bc.map(el => {
            array.push(this.symbols.find(filter => filter.baseAsset == el.baseAsset && filter.quoteAsset == this.selected_symbol))
          })
          relation = array
        }
        console.log(relation)
        return relation
      }
    },
    methods:{
      async startWebSocket(){
        localStorage.setItem('symbol', this.selected_symbol)

        this.max_hist_volume = 0
        this.socket ? this.socket.close() : null
        this.socket = new WebSocket(`wss://stream.binance.com:9443/stream?streams=${this.websocket_symboles}`);

        //Listen websocket
        let vm = this
        this.socket.addEventListener('message', function (data) {
            let json = JSON.parse(data.data)
            vm.best_offer = json.data
        })
      },
      getSymbols(){
        const req = axios.get('https://api.binance.com/api/v3/exchangeInfo')
        this.symbols = req.data
        return this.symbols
      }
    }
  }
</script>
<style scoped>
.app{
  font-size: 1em;
}
</style>